1#!/bin/sh
2
3################################################################################
4##                                                                            ##
5## Copyright (c) International Business Machines  Corp., 2006                 ##
6##                                                                            ##
7## This program is free software;  you can redistribute it and#or modify      ##
8## it under the terms of the GNU General Public License as published by       ##
9## the Free Software Foundation; either version 2 of the License, or          ##
10## (at your option) any later version.                                        ##
11##                                                                            ##
12## This program is distributed in the hope that it will be useful, but        ##
13## WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY ##
14## or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License   ##
15## for more details.                                                          ##
16##                                                                            ##
17## You should have received a copy of the GNU General Public License          ##
18## along with this program;  if not, write to the Free Software               ##
19## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA    ##
20##                                                                            ##
21##                                                                            ##
22################################################################################
23#
24# File:
25#   mcast6-queryfld01
26#
27# Description:
28#   Verify that the kernel is not crashed when joining an IPv6 multicast
29#   group on a single socket, then receiving a large number of General Query
30#
31# Setup:
32#   See testcases/network/stress/README
33#
34# Author:
35#   Mitsuru Chinen <mitch@jp.ibm.com>
36#
37# History:
38#	May 7 2006 - Created (Mitsuru Chinen)
39#
40#-----------------------------------------------------------------------
41# Uncomment line below for debug output.
42#trace_logic=${trace_logic:-"set -x"}
43$trace_logic
44
45# The test case ID, the test case count and the total number of test case
46TCID=mcast6-queryfld01
47TST_TOTAL=1
48TST_COUNT=1
49export TCID
50export TST_COUNT
51export TST_TOTAL
52
53# Make sure the value of LTPROOT
54LTPROOT=${LTPROOT:-`(cd ../../../../.. ; pwd)`}
55export LTPROOT
56
57# Check the environmanet variable
58. check_envval || exit $TST_TOTAL
59
60# Dulation of the test [sec]
61NS_DURATION=${NS_DURATION:-3600}	# 1 hour
62
63# The number of the test link where tests run
64LINK_NUM=${LINK_NUM:-0}
65
66# Network portion of the IPv6 address
67NETWORK_PART="fec0:1:1:1"
68
69# Host portion of the IPv6 address
70LHOST_HOST_PART=":2"	# local host
71RHOST_HOST_PART=":1"	# remote host
72
73# Prefix of the Multicast Address
74MCAST_ADDR_PREFIX=ff0e:
75
76
77#-----------------------------------------------------------------------
78#
79# Function: do_cleanup
80#
81# Description:
82#   Recover the system configuration
83#
84#-----------------------------------------------------------------------
85do_cleanup()
86{
87    # Make sure to kill the multicast receiver and sender
88    killall -SIGHUP ns-mcast_join >/dev/null 2>&1
89    $LTP_RSH $RHOST killall -SIGHUP ns-icmpv6_sender >/dev/null 2>&1
90
91    # Clean up each interface
92    initialize_if lhost ${LINK_NUM}
93    initialize_if rhost ${LINK_NUM}
94}
95
96
97#-----------------------------------------------------------------------
98#
99# Function: do_setup
100#
101# Description:
102#   Configure the ssystem for the test
103#
104#-----------------------------------------------------------------------
105do_setup()
106{
107    # Initialize the system configuration
108    do_cleanup
109
110    # Call do_cleanup function before exit
111    trap do_cleanup 0
112
113    # name of interface of the local/remote host
114    lhost_ifname=`get_ifname lhost $LINK_NUM`
115    if [ $? -ne 0 ]; then
116	tst_resm TBROK "Failed to get the interface name at the local host"
117	exit $TST_TOTAL
118    fi
119
120    rhost_ifname=`get_ifname rhost $LINK_NUM`
121    if [ $? -ne 0 ]; then
122	tst_resm TBROK "Failed to get the interface name at the remote host"
123	exit $TST_TOTAL
124    fi
125
126    # Set IPv6 addresses to the interfaces
127    add_ipv6addr lhost $LINK_NUM $NETWORK_PART $LHOST_HOST_PART
128    if [ $? -ne 0 ]; then
129	tst_resm TBROK "Failed to add any IP address at the local host"
130	exit 1
131    fi
132
133    add_ipv6addr rhost $LINK_NUM $NETWORK_PART $RHOST_HOST_PART
134    if [ $? -ne 0 ]; then
135	tst_resm TBROK "Failed to add any IP address at the remote host"
136	exit 1
137    fi
138
139    # IPv6 address of the local/remote host
140    lhost_addr="${NETWORK_PART}:${LHOST_HOST_PART}"
141    rhost_addr="${NETWORK_PART}:${RHOST_HOST_PART}"
142    rhost_linklocal="fe80:${RHOST_HOST_PART}"
143
144    # Make sure the connectvity
145    check_icmpv6_connectivity $lhost_ifname $rhost_addr
146    if [ $? -ne 0 ]; then
147	tst_resm TBROK "There is no IPv6 connectivity."
148	exit 1
149    fi
150
151    # Make sure the sysctl values
152    sysctl -w net.ipv6.conf.all.force_mld_version=0 >/dev/null
153    if [ $? -ne 0 ]; then
154	tst_resm TBROK "Failed to set the sysctl value regarding multicast"
155	exit $TST_TOTAL
156    fi
157
158    sysctl -w net.ipv6.conf.${lhost_ifname}.force_mld_version=0 >/dev/null
159    sysctl -w net.ipv6.mld_max_msf=10 >/dev/null
160}
161
162
163#-----------------------------------------------------------------------
164#
165# Main
166#
167#
168
169# Test description
170tst_resm TINFO "Verify that the kernel is not crashed when joining an IPv6 multicast group on a single socket, then receiving a large number of General Query in $NS_DURATION [sec]"
171
172do_setup
173
174# Run a multicast join tool
175ns-mcast_join -f 6 -I $lhost_ifname -n 1 -p $MCAST_ADDR_PREFIX >/dev/null
176if [ $? -ne 0 ]; then
177    tst_resm TBROK "Failed to start multicast joining tool Please check the environment"
178    exit 1
179fi
180
181# Send MLD General Query from the remote host
182ret=`$LTP_RSH $RHOST ${LTPROOT}/testcases/bin/ns-icmpv6_sender -I $rhost_ifname -S $rhost_linklocal -m -r 0 -t $NS_DURATION' ; echo $?'`
183
184if [ $ret -ne 0 ]; then
185    tst_resm TBROK "Failed to start MLD querier"
186    exit 1
187fi
188
189#-----------------------------------------------------------------------
190#
191# Clean up
192#
193
194killall -SIGHUP ns-mcast_join >/dev/null 2>&1
195tst_resm TPASS "Test is finished successfully."
196
197exit 0
198